package javazoom.jlGui.playlist;

/**
 * PlaylistItem.
 *
 *-----------------------------------------------------------------------
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as published
 *   by the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *----------------------------------------------------------------------
 */

/**
 * PlaylistItem.
 *
 * @author	E.B from JavaZOOM
 *
 * Homepage : http://www.javazoom.net
 */
public class PlaylistItem
{
	protected String	_name = null;
	protected String	_location = null;
	protected boolean	_isFile = true;
	protected long		_seconds = -1;
    protected boolean   _isSelected = false ;  // add by JOHN YANG

	protected PlaylistItem()
	{
	}

	public PlaylistItem(String name, String location, long seconds, boolean isFile)
	{
		_name = name;
		_location = location;
		_seconds = seconds;
		_isFile = isFile;
	}

	public String getName()
	{
		return _name;
	}

	public String getDisplay()
	{
		return _name;
	}

	public String getLocation()
	{
		return _location;
	}

	public boolean isFile()
	{
		return _isFile;
	}

	public long getLength()
	{
		return _seconds;
	}

    public void setSelected (boolean mode)
    {
        _isSelected = mode ;
    }

    public boolean isSelected ()
    {
        return _isSelected ;
    }

    public void setLocation(String l)
    {
        _location = l;
    }
}
